<?php
/*
The script to check/convert older spoiler tags.
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty.
Check COPYING file for more details.
Copyright (C) 2016 Paul Puzyrev. www.minibb.com
Latest File Update: 2016-Sep-05
*/

define ('INCLUDED776',1);
//archives
//define('ARCHIVE', '2005-2009');

include('./setup_options.php');
include($pathToFiles.'setup_'.$DB.'.php');
include($pathToFiles.'bb_functions.php');

/* Important Settings - Change URL to your forum here! */

$quotePatterns=array(
0=>'#<div class="spoiler">#',
);
//set up this array, so msg number always belongs to the #3 pattern

$replacePatterns=array(
0=>'<div class="spoiler" id="spoiler{SPOILER_ID}" onclick="javascript:unspoil(this);">',
);

$convertMode=FALSE; //TRUE - live update DB; FALSE - tests only

$start_id=10000000000000000; //should consist precisely of 17 digits

/* --Important Settings */


/* Optional Settings - they should do work with no modifying, and are for debugging/experienced coders only. */

$purgeSortOrder='topic_id ASC, post_id ASC';

$purgeTb=$Tp; //name of the posts table

$purgeField='post_text'; //name of the valuable field in the posts table

$purgeId='post_id'; //the unique ID of the posts table

$purgeFields='forum_id, topic_id';

$purgeGoPost='./msg.php?id=[POST_ID]';

$recordsLimit=30000; //the portion of selected records AT ONCE

$purgeLimited=FALSE; // the output will be limited to $recordsLimit amount only

/* --Optional Settings */


set_time_limit(0);

function get_microtime() {
$mtime=explode(' ',microtime());
return $mtime[1]+$mtime[0];
}

$starttime=get_microtime();
if(!defined('PAGE1_OFFSET')) define('PAGE1_OFFSET', 0);

$cnt=0;
$cntTotal=0;

$uSql="select count(*) from {$purgeTb}";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))) 
$numRows=$row[0]; else $numRows=0;

echo <<<out
<!doctype html>
<html>
<head>
<title>Tags Finding/Conversion</title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
<link href="{$main_url}/bb_{$skin}_style.css" type="text/css" rel="stylesheet">
<script type="text/javascript" src="{$main_url}/templates/form.js"></script>
</head>
<body class="gbody" style="background:#fff">
out;

function convert_quote($quotePatterns, $replacePatterns, $text){
//echo $replacePatterns[0].'<br>';
//$replacePatterns_tmp=$replacePatterns[0];
//$replacePatterns[0]=str_replace('{SPOILER_ID}', $GLOBALS['start_id'], $replacePatterns[0]);
$text=preg_replace($quotePatterns, $replacePatterns, $text);
//$GLOBALS['replacePatterns'][0]=$replacePatterns_tmp;
//$GLOBALS['start_id']++;
//echo $GLOBALS['start_id'];
return $text;
}

function extraSpacesBR($text){
$txt=preg_replace("#[ ]+<br>#", '<br>', $text);
$txt=preg_replace("#<br>[ ]+#", '<br>', $txt);
$txt=preg_replace("#<br>[\r\n]+#", '<br>', $txt);
$txt=preg_replace("#[\r\n]+<br>#", '<br>', $txt);
return $txt;
}

/*********************/

if(isset($_GET['action']) and $_GET['action']=='test'){

$post=(int)$_GET['post'];

$uSql="select {$purgeId}, {$purgeField} from {$purgeTb}  where {$purgeId}={$post}";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

$replacePatterns_tmp=$replacePatterns[0];
$replacePatterns[0]=str_replace('{SPOILER_ID}', (int)$_GET['start_id'], $replacePatterns[0]);

$quoteNew=convert_quote($quotePatterns, $replacePatterns, $row[1]);

$replacePatterns[0]=$replacePatterns_tmp;

//$quoteNew=extraSpacesBR($quoteNew);

echo $row[1].'<hr size="1"><br><h2>FIXED:</h2><br><div class="sp" style="background:#ffe">'.$quoteNew.'</div><hr size="1"><br><b>HTML</b>:<br><br>'.str_replace(array("\n", "\r"), '<br>', operate_string($quoteNew)).'<br><br>';

}

}

else{

echo 'Total Records: <b>'.$numRows.'</b><br /></b><br /><hr size="1" style="color:#ccc"><br />';

$cont='';

if($purgeLimited) $numRows=$recordsLimit;

if($numRows>0){

/****************/

$startOffset=0;
$currRec=0;
$supposeConverted=0;
$firstPageMsgs=0;
$nextPageMsgs=0;

while($startOffset<$numRows){

$uSql="select {$purgeId}, {$purgeField}, {$purgeFields} from {$purgeTb} order by {$purgeSortOrder} limit {$startOffset}, {$recordsLimit}";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

do{

$foundq=FALSE;
$idCurrent=$row[0];
$ptextCurrent=$row[1];
//$topic=$row[3];
//$tSize=round(strlen($ptextCurrent)/1024, 2).' Kb';

foreach($quotePatterns as $key=>$qp){
if(preg_match($qp, $ptextCurrent, $arr)) {

if(!$foundq) {

$detPostId=$arr[3];

//determining the msg page#
if(isset($themeDesc) and in_array($topic,$themeDesc)) $vv=TRUE; else $vv=FALSE;
if(!$vv) $sg='<='; else $sg='>=';

if($row2=db_simpleSelect(0, $purgeTb, 'topic_id', 'post_id', '=', $detPostId)) $topic=$row2[0]; else $topic=0;
if($row2=db_simpleSelect(0, $purgeTb, 'count(*)', 'post_id', $sg, $detPostId, '', '', 'topic_id', '=', $topic)) $pt=$row2[0]; else $pt=0;

if($pt<=$viewmaxreplys) {
$page=PAGE1_OFFSET+1;
$pb1='';$pb2='';
$firstPageMsgs++;
}
else {
$page=ceil($pt/$viewmaxreplys)+PAGE1_OFFSET;
$pb1='<b>';$pb2='</b>';
$nextPageMsgs++;
}


$replacePatterns_tmp=$replacePatterns[0];
$replacePatterns[0]=str_replace('{SPOILER_ID}', $start_id, $replacePatterns[0]);
$start_id++;

echo "<!--{$key} :: -->&nbsp;&nbsp;<a href=\"".str_replace('[POST_ID]', $idCurrent, $purgeGoPost)."\" target=\"_blank\">{$idCurrent}</a> [{$detPostId}--{$topic}] | <a href=\"./spoiler_msg_convert.php?action=test&amp;post={$idCurrent}&amp;start_id={$start_id}\" target=\"_blank\">Test</a> {$pb1}{$page}{$pb2}<br>";

if($convertMode){

$quoteNew=convert_quote($quotePatterns, $replacePatterns, $ptextCurrent);
$quoteNew=extraSpacesBR($quoteNew);

$sql_q="update {$purgeTb} set {$purgeField}='{$quoteNew}' where {$purgeId}={$idCurrent}";

if($DB=='mysql') mysql_query($sql_q);
elseif($DB=='mysqli') mysqli_query($mysqlink, $sql_q);

}

$replacePatterns[0]=$replacePatterns_tmp;

}

$foundq=TRUE;

}
}

if($foundq) $supposeConverted++;

}
while( ($DB=='mysql' and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $row=mysqli_fetch_row($res)) );


}


$startOffset=$startOffset+$recordsLimit;

}

/****************/

}

$ratio=floor($nextPageMsgs*100/($supposeConverted)).'%';

echo '<hr size="1"><br />Total Matched: '.$supposeConverted.'<br />';

$endtime=get_microtime();
$totaltime=sprintf ("%01.3f", ($endtime-$starttime));
echo '<br /><br />Total Time: '.$totaltime;

}

echo '</body></html>';

?>